/*-----------------------------------------------------------------------
 * Copyright 1999 Michael Lincoln <mclinc@essex.ac.uk>
 * 
 * This software is provided free of charge.  Permission is hereby given
 * to use, copy, modify and distribute free of charge the software for
 * any purpose provided that this notice is included verbatim in every
 * copy.  The software is provided on an "as is" basis and the authors
 * and the University of Essex have no obligation to provide maintenance,
 * support, updates, enhancements, or modifications.
 * 
 * All express or implied warranties whether statutory or otherwise as to
 * the merchantability or fitness for a particular purpose of the
 * software are, to the maximum extent permitted by law, excluded.
 *
 * In no circumstances whatsoever shall the author or the University of
 * Essex be liable in contract, tort, or otherwise including liability
 * for negligence for any loss whether direct, indirect or otherwise of
 * business, revenue, profits, anticipated savings, wasted expenditure,
 * corruption or destruction of data or for any indirect or consequential
 * loss whatsoever.
 * 
 *
 *------------------------------------------------------------------------
 */





#include <termios.h> //included for termios def

class visca
{
 public:
  visca(char *portname);
  ~visca();
  int send_command(int address,int data_length,unsigned char* data);
  int send_inquirie(int address,unsigned char *inquirie,int &data_length,unsigned char *data);

 private:
  //packet types
      
  //things you can send
  const unsigned char COM = 0x01;  //command 
  const unsigned char INQ = 0x09;  //inquirie
  const unsigned char RST = 0x30;  //network reset *must broadcast to address 8
			           // and send 0x01 as the data.
  //things you can receive
  const unsigned char ACK = 0x04;  //acknolagement
  const unsigned char CMP = 0x05;  //compleation
  const unsigned char ERR = 0x06;  //error
  const unsigned char NET = 0x38;  //network change
 

  //send a packet
  int send_packet(int address,int type,int data_length,unsigned char* data);
  //received a packet
  int recv_packet(int &address,int &type,int &socket,int &data_length,unsigned char* data);
  //deal with a packet that the current method isnt interested in 
  // (eg an error,network reset or compleation)
  int uninterestingPacket(int address,int type,int socket,int dataLength,unsigned char* data);
  

  int socketInuse[3];
 
  input_framework();
  unsigned char myaddress;
  int comdev;
  struct termios savedSettings;
  struct termios newSettings;

};


class cam
{
 public:
  cam(char *portname,int camAddress);
  ~cam();
  int powerOn(int value);
  int move(int x,int y);
  int zoom(int z);
  int waitComplete();
  int getPos(int &x,int &y);
  int getZoom(int &z);
  
 private:
  int myCamAddress;
  visca *myViscaPTR;
  int lastX,lastY,lastZ;
};

